libzypp: zypp::CapDetail Class Reference

libzypp 17.36.6

Public Types | Public Member Functions | Related Symbols | List of all members
zypp::CapDetail Class Reference

Helper providing more detailed information about a Capability. More...

`#include <zypp/Capability.h>`

Inheritance diagram for zypp::CapDetail:

## Public Types
enum | Kind { NOCAP = 0x00 , NAMED = 0x01 , VERSIONED = 0x02 , EXPRESSION = 0x04 }
enum | CapRel { REL_NONE = 0 , CAP_AND = 16 , CAP_OR = 17 , CAP_COND = 22 , CAP_UNLESS = 29 , CAP_ELSE = 26 , CAP_WITH = 18 , CAP_WITHOUT = 28 , CAP_NAMESPACE = 19 , CAP_ARCH = 20 }
| Enum values corresponding with libsolv defines. More...

## Public Member Functions
| CapDetail ()
| CapDetail (const Capability &cap_r)
| CapDetail (sat::detail::IdType id_r)
Kind | kind () const
bool | isNull () const
bool | isNamed () const
bool | isVersioned () const
bool | isSimple () const
bool | isExpression () const
Is simple: <tt>name[.arch] [op edition]</tt>
bool | hasArch () const
IdString | arch () const
IdString | name () const
Rel | op () const
Edition | ed () const

## Related Symbols
(Note that these are not member symbols.)
std::ostream & | operator<< (std::ostream &str, const CapDetail &obj) ZYPP_API
| Stream output.
std::ostream & | operator<< (std::ostream &str, CapDetail::Kind obj) ZYPP_API
| Stream output.
std::ostream & | operator<< (std::ostream &str, CapDetail::CapRel obj) ZYPP_API
| Stream output.

## Is expression <tt>cap op cap</tt>
Kind | _kind
sat::detail::IdType | _lhs
sat::detail::IdType | _rhs
unsigned | _flag
sat::detail::IdType | _archIfSimple
Capability | lhs () const
CapRel | capRel () const
Capability | rhs () const
void | _init ()

## Additional Inherited Members
Static Protected Member Functions inherited from zypp::sat::detail::PoolMember
static PoolImpl & | myPool ()

## Detailed Description

Helper providing more detailed information about a Capability.

Capabilities are classified to be either `SIMPLE:`

name[.arch] [op edition]
with op := <|<=|=|>=|>|!=
zypp::CapDetail::name
IdString name() const
Definition Capability.h:363
zypp::CapDetail::op
Rel op() const
Definition Capability.h:364

or formed by some `EXPRESSION:`

( left_cap op right_cap )
with op := and|or|if|unless|else|with|without

Definition at line 309 of file Capability.h.

## Member Enumeration Documentation

## ◆ Kind

enum zypp::CapDetail::Kind

Enumerator
NOCAP |
NAMED |
VERSIONED |
EXPRESSION |

Definition at line 312 of file Capability.h.

## ◆ CapRel

enum zypp::CapDetail::CapRel

Enum values corresponding with libsolv defines.

Note
  MPL check in PoolImpl.cc

Enumerator
REL_NONE | Not an expression.
CAP_AND | `and`
CAP_OR | `or`
CAP_COND | `if`
CAP_UNLESS | `unless`
CAP_ELSE | `else`
CAP_WITH | `with`
CAP_WITHOUT | `without`
CAP_NAMESPACE |
CAP_ARCH | Used internally.

Definition at line 323 of file Capability.h.

## Constructor & Destructor Documentation

## ◆ CapDetail() [1/3]

zypp::CapDetail::CapDetail | ( |  | ) |
| inline

Definition at line 341 of file Capability.h.

## ◆ CapDetail() [2/3]

zypp::CapDetail::CapDetail | ( | const Capability & | cap_r | ) |
| inlineexplicit

Definition at line 344 of file Capability.h.

## ◆ CapDetail() [3/3]

zypp::CapDetail::CapDetail | ( | sat::detail::IdType | id_r | ) |
| inlineexplicit

Definition at line 347 of file Capability.h.

## Member Function Documentation

## ◆ kind()

Kind zypp::CapDetail::kind | ( |  | ) | const
| inline

Definition at line 352 of file Capability.h.

## ◆ isNull()

bool zypp::CapDetail::isNull | ( |  | ) | const
| inline

Definition at line 353 of file Capability.h.

## ◆ isNamed()

bool zypp::CapDetail::isNamed | ( |  | ) | const
| inline

Definition at line 354 of file Capability.h.

## ◆ isVersioned()

bool zypp::CapDetail::isVersioned | ( |  | ) | const
| inline

Definition at line 355 of file Capability.h.

## ◆ isSimple()

bool zypp::CapDetail::isSimple | ( |  | ) | const
| inline

Definition at line 356 of file Capability.h.

## ◆ isExpression()

bool zypp::CapDetail::isExpression | ( |  | ) | const
| inline

Definition at line 357 of file Capability.h.

## ◆ hasArch()

bool zypp::CapDetail::hasArch | ( |  | ) | const
| inline

Definition at line 361 of file Capability.h.

## ◆ arch()

IdString zypp::CapDetail::arch | ( |  | ) | const
| inline

Definition at line 362 of file Capability.h.

## ◆ name()

IdString zypp::CapDetail::name | ( |  | ) | const
| inline

Definition at line 363 of file Capability.h.

## ◆ op()

Rel zypp::CapDetail::op | ( |  | ) | const
| inline

Definition at line 364 of file Capability.h.

## ◆ ed()

Edition zypp::CapDetail::ed | ( |  | ) | const
| inline

Definition at line 365 of file Capability.h.

## ◆ lhs()

Capability zypp::CapDetail::lhs | ( |  | ) | const
| inline

Definition at line 370 of file Capability.h.

## ◆ capRel()

CapRel zypp::CapDetail::capRel | ( |  | ) | const
| inline

Definition at line 371 of file Capability.h.

## ◆ rhs()

Capability zypp::CapDetail::rhs | ( |  | ) | const
| inline

Definition at line 372 of file Capability.h.

## ◆ _init()

void zypp::CapDetail::_init | ( |  | ) |
| private

Definition at line 591 of file Capability.cc.

## Friends And Related Symbol Documentation

## ◆ operator<<() [1/3]

std::ostream & operator<< | ( | std::ostream & | str,
|  | const CapDetail & | obj )
| related

Stream output.

Definition at line 648 of file Capability.cc.

## ◆ operator<<() [2/3]

std::ostream & operator<< | ( | std::ostream & | str,
|  | CapDetail::Kind | obj )
| related

Stream output.

Definition at line 696 of file Capability.cc.

## ◆ operator<<() [3/3]

std::ostream & operator<< | ( | std::ostream & | str,
|  | CapDetail::CapRel | obj )
| related

Stream output.

Definition at line 708 of file Capability.cc.

## Member Data Documentation

## ◆ _kind

Kind zypp::CapDetail::_kind
| private

Definition at line 378 of file Capability.h.

## ◆ _lhs

sat::detail::IdType zypp::CapDetail::_lhs
| private

Definition at line 379 of file Capability.h.

## ◆ _rhs

sat::detail::IdType zypp::CapDetail::_rhs
| private

Definition at line 380 of file Capability.h.

## ◆ _flag

unsigned zypp::CapDetail::_flag
| private

Definition at line 381 of file Capability.h.

## ◆ _archIfSimple

sat::detail::IdType zypp::CapDetail::_archIfSimple
| private

Definition at line 382 of file Capability.h.

The documentation for this class was generated from the following files:

- zypp/Capability.h
- zypp/Capability.cc